
#include <algorithm>
#include <iostream>
#include <vector>

#include "mod_adt.h"

typedef struct {
  std::vector<int> count;
  std::vector<std::string> names;
} implNames;

Names new_Names() {
  return new implNames;
}

void dump( Names names ) {
  implNames* in = (implNames*)names;

  std::vector<std::string>::iterator
    it = in->names.begin();
  std::vector<int>::iterator
    jt = in->count.begin();

  for (; it != in->names.end(); ++it, ++jt)
    std::cout << *it << ":" << *jt
              << std::endl;

  std::cout << std::endl;
}

void insert( Names names, std::string n ) {
  implNames* in = (implNames*)names;

  std::vector<std::string>::iterator
    it = lower_bound( in->names.begin(),
                      in->names.end(), n );

  if (it == in->names.end()) {
    in->names.insert( it, n );
    in->count.insert( in->count.end(), 1 );
  } else {
    if (*it != n) {
      in->count.insert( in->count.begin() +
                        (it - in->names.begin()),
                        1 );
      in->names.insert( it, n );
    } else {
      ++(*( in->count.begin() +
            (it - in->names.begin()) ));
    }
  }
}

void remove( Names names, int i ) {
  implNames* in = (implNames*)names;

  if (--(in->count[i]) == 0) {
    in->names.erase( in->names.begin() + i );
    in->count.erase( in->count.begin() + i );
  }
}

std::string get( Names names, int i ) {
  implNames* in = (implNames*)names;

  return in->names[i];
}

