
#include <algorithm>
#include <iostream>

#include "mod_oo.h"

Names::Names() {};

void Names::dump() {

  std::vector<std::string>::iterator
    it = this->names.begin();
  std::vector<int>::iterator
    jt = this->count.begin();

  for (; it != this->names.end(); ++it, ++jt)
    std::cout << *it << ":" << *jt
              << std::endl;

  std::cout << std::endl;
}

void Names::insert( std::string n ) {

  std::vector<std::string>::iterator
    it = lower_bound( this->names.begin(),
                      this->names.end(), n );

  if (it == this->names.end()) {
    this->names.insert( it, n );
    this->count.insert( this->count.end(), 1 );
  } else {
    if (*it != n) {
      this->count.insert( this->count.begin() +
                        (it - this->names.begin()),
                        1 );
      this->names.insert( it, n );
    } else {
      ++(*( this->count.begin() +
            (it - this->names.begin()) ));
    }
  }
}

void Names::remove( int i ) {
  if (--(this->count[i]) == 0) {
    this->names.erase( this->names.begin() + i );
    this->count.erase( this->count.begin() + i );
  }
}

std::string Names::get( int i ) {
  return this->names[i];
}

